//the following is a hack because xojo doesn't always create the namespace before you try to add things to it
Xojo.createNamespace("XTension.vslider");

XojoCustom.XTension.vslider.setupDrag = function( theCanvas, theData){
	XojoCustom.XTension.vslider.makeData( theCanvas, theData);
	if (theData.blocked)
		return false;
	
	if (!e)
		var e = event;
	var mouseY = e.pageY - XojoCustom.XTension.vslider.findTop( theCanvas);
	
	//are we within the paddle
	//var paddleStart = ((theData.value - theData.min) * theData.perPixelChange) + 2;
	var paddleStart = ((theData.max - theData.value) * theData.perPixelChange) + 2;
	if ((mouseY > paddleStart) && (mouseY < (paddleStart + theData.paddleHeight))){
		theData.mouseStart = mouseY - paddleStart + 2; //+2 to remove border calculation here
		theData.isDragging = true;
		
		var workDisplay = document.getElementById( theData.displayid);
		
		if (theData.manageDisplayVisibility == true){
			workDisplay.style.display = "block";
		}
		//workDisplay.style.top = (XojoCustom.XTension.vslider.findTop( theCanvas) - 65) + "px";
		//display doesn't move for these
		return true;
	} else {
		return false;
	}
	
}

XojoCustom.XTension.vslider.setBlocked = function( theValue, theCanvas, theData){
	if (theValue != theData.blocked){
		theData.blocked = theValue; 
		XojoCustom.XTension.vslider.drawSlider( theCanvas, theData);
	}
}


XojoCustom.XTension.vslider.makeData = function( theCanvas, theData){
	theData.valueAtDragStart = theData.value;
	theData.usableHeight = theCanvas.height - theData.paddleHeight - 4; //-4 for border paddleWidth is 25
	theData.actualRange = theData.max - theData.min;
	theData.perPixelChange = theData.usableHeight / theData.actualRange;
}


XojoCustom.XTension.vslider.mouseDown = function( theCanvas, theData){
	 if (XojoCustom.XTension.vslider.setupDrag( theCanvas, theData)){	
		XojoCustom.XTension.vslider.mouseMove( theCanvas, theData);
	}
}

XojoCustom.XTension.vslider.touchStart = function( theCanvas, theData){
	 if (XojoCustom.XTension.vslider.setupDrag( theCanvas, theData)){
		XojoCustom.XTension.vslider.touchMove( theCanvas, theData);
	}
}


XojoCustom.XTension.vslider.mouseMove = function( theCanvas, theData){
	if (! theData.isDragging){
		return;
	}
	var e = event;
	if (!e)
		var e = event;
		
	var localY = e.pageY - XojoCustom.XTension.vslider.findTop( theCanvas) - theData.mouseStart;
	
	//theData.value = theData.min + (localY / theData.perPixelChange);
	theData.value =  theData.max - (localY / theData.perPixelChange);
	
	if (theData.value < theData.min)
		theData.value = theData.min;

	
	if (theData.value > theData.max)
		theData.value = theData.max;
		
	XojoCustom.XTension.vslider.drawSlider( theCanvas, theData);
}


XojoCustom.XTension.vslider.touchMove = function( theCanvas, theData){
	if (! theData.isDragging){
		return;
	}
	
	var e = event;
	if (!e)
		var e = event;
		
	e.preventDefault();
	var localY = e.pageY - XojoCustom.XTension.vslider.findTop( theCanvas) - theData.mouseStart;
	
	//theData.value = theData.valueAtDragStart - (localX / theData.perPixelChange);
	//theData.value = theData.min + (localY / theData.perPixelChange);
	theData.value =  theData.max - (localY / theData.perPixelChange);
	
	//var logline = "touchmove localY=" + localY;
	//Xojo.triggerServerEvent( theData.controlid, "writelog", [logline]);
	
	if (theData.value < theData.min){
		theData.value = theData.min;
	}
	
	if (theData.value > theData.max){
		theData.value = theData.max;
	}
		
	XojoCustom.XTension.vslider.drawSlider( theCanvas, theData);
}


XojoCustom.XTension.vslider.mouseUp = function( theCanvas, theData){

	if (theData.isDragging){
		Xojo.triggerServerEvent( theData.controlid, "changed", [theData.value]);
	}
	
	theData.isDragging = false;
	XojoCustom.XTension.vslider.drawSlider( theCanvas, theData); //to clear highlight
	if (theData.manageDisplayVisibility){
		Xojo.get( theData.displayid).style.display = "none";
	}
}

XojoCustom.XTension.vslider.touchEnd = function( theCanvas, theData){
	if (theData.isDragging){
		Xojo.triggerServerEvent( theData.controlid, "changed", [theData.value]);
	}
	
	theData.isDragging = false;
	XojoCustom.XTension.vslider.drawSlider( theCanvas, theData); //to clear highlight
	if (theData.manageDisplayVisibility){
		Xojo.get( theData.displayid).style.display = "none";
	}

	
}


XojoCustom.XTension.vslider.drawSlider = function( theCanvas, theData){
	var lineWidth = 1;
	if (! theCanvas)
		return;
		
	var ctx = theCanvas.getContext( "2d");
	
	
	//clear and draw the background
	ctx.clearRect( 0, 0, theCanvas.width, theCanvas.height);
	ctx.lineWidth = lineWidth;
	

	//in this case we let the background show through.
	
	var paddleStart = ((theData.max - theData.value) * theData.perPixelChange) + lineWidth;
	
	
	if (theData.blocked){
		ctx.fillStyle = "rgb( 200, 200, 200)";
		ctx.globalAlpha = 0.6;
		ctx.fillRect( 0, 0, theCanvas.width, theCanvas.height);
		ctx.globalAlpha = 1;
		ctx.strokeStyle = "grey";
	} else {
		ctx.strokeStyle = "rgb( 10, 10, 10)";
		if (theData.isDragging){
			ctx.fillStyle = "rgb( 100, 100, 255)";
		} else {
		
			var my_gradient=ctx.createLinearGradient(0,paddleStart,0,paddleStart + theData.paddleHeight);
			my_gradient.addColorStop(0,"#888892");
			my_gradient.addColorStop(1,"#BBBBC2");
			ctx.fillStyle = my_gradient;
		}
	}
	
	//let the CSS draw the border
	//XojoCustom.XTension.vslider.roundRect( ctx, 1, 1, theCanvas.width-1, theCanvas.height-1, 10)
	//ctx.stroke();
	
	
	//draw the paddle
	// must invert the value for placement calculation
	
	//var paddleStart = ((theData.value - theData.min) * theData.perPixelChange) + 2
	
	//XojoCustom.XTension.vslider.roundRect( ctx, paddleStart, 2, paddleStart + theData.paddleWidth, theCanvas.height-2, 10);
	XojoCustom.XTension.vslider.roundRect( ctx, lineWidth, paddleStart, theCanvas.width-lineWidth, paddleStart + theData.paddleHeight, 10);
	ctx.fill();
	ctx.stroke();
	
	//var canvasOffset = XojoCustom.XTension.vslider.findLeft( theCanvas);
	
	//document.getElementById( theData.displayid).style.left = Math.round(((paddleStart + (theData.paddleWidth / 2)) - (75 / 2)) + canvasOffset )+ "px";
	document.getElementById( theData.displayid).innerHTML = "<b>" + Math.round( theData.value) + "</b>";	
}	

XojoCustom.XTension.vslider.findLeft = function( obj){
	var bodyRect = document.body.getBoundingClientRect(),
		elemRect = obj.getBoundingClientRect();
		return elemRect.left - bodyRect.left;
}
XojoCustom.XTension.vslider.findTop = function( obj){
	var bodyRect = document.body.getBoundingClientRect(),
		elemRect = obj.getBoundingClientRect();
		return elemRect.top - bodyRect.top;
}

XojoCustom.XTension.vslider.roundRect = function( ctx, sx, sy, ex, ey, r){
	var r2d = Math.PI / 180;
	
	ctx.beginPath();
	ctx.moveTo(sx+r,sy);
    ctx.lineTo(ex-r,sy);
    ctx.arc(ex-r,sy+r,r,r2d*270,r2d*360,false);
    ctx.lineTo(ex,ey-r);
    ctx.arc(ex-r,ey-r,r,r2d*0,r2d*90,false);
    ctx.lineTo(sx+r,ey);
    ctx.arc(sx+r,ey-r,r,r2d*90,r2d*180,false);
    ctx.lineTo(sx,sy+r);
    ctx.arc(sx+r,sy+r,r,r2d*180,r2d*270,false);
    ctx.closePath();

}